{% load static %}

{% include 'sub_templates/base.html' %}
{{'reportes_generados.scss'|css_compiler|safe}}

<head>
  <title>Documentacion {{project.name}} {{date_str}}</title>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/jspdf/1.2.61/jspdf.min.js"></script>
  <script type="text/javascript">
    // $( document ).ready( function (){
    // })

    // var doc = new jsPDF();
    // var specialElementHandlers = {
    //   '#editor': function (element, renderer) {
    //     return true;
    //   }
    // };

    function save_pdf() {
      window.print();
      // doc.fromHTML($('body').html(), 15, 15, {
      //   'width': 170,
      //   'elementHandlers': specialElementHandlers
      // });
      // doc.save('Documentacion {{project.name}} {{date_str}}');
    };
  </script>
</head>

<body>
  <div class="title">
    <h1 class="text-center">Documentacion Generada {{project.name}} ({{date}})</h1>
  </div>
  <button id="save-pdf" class="btn btn-secondary" type=button onclick="save_pdf();">Guardar como PDF</button>
  <div class="position-absolute ml-4 mt-3" style="width: 2.6rem;">
    <a href="/{{project.id}}/reportes">{{'arrow-left-solid.svg'|svgColor:'var(--light)'|safe}}</a>
  </div>
  <div class="content centerX" method="POST" action="/generate_reports/{{project_id}}">
    {% for test_types in tests %}
    <div class="children">
      <h1> {{test_types.name}} </h1>
      <div class="sub-menu-items">
        {% for test_type in test_types.childrens %}
        <div class="children">
          <h2> {{test_type.name}} </h2>
          <div class="sub-menu-items">
            {% for section in test_type.childrens %}
            <div class="children">
              <h3> Sección: {{section.name}} </h3>
              <div class="sub-menu-items">
                {% for test in section.childrens %}
                <div class="card bg-light mb-3">
                  <h5 class="card-header"><a href="{{ test|get_test_url }}">Prueba: "{{test.title|replace_env_vars:project.id}}"</a></h5>
                  {% if show_detail %}
                  <div class="detail">
                    <div class="card-body">
                      <h5 class="card-title">Detalle</h5>
                      {% if test_type.value == 'queries' %}
                        <div class="method-url">
                          {{ test|get_query_route:project.id }}
                        </div>
                        <div class="row mt-3">
                          <div class="headers row col-6">
                            <h6 class="col-3">Headers</h6>
                            <pre class="col-9">{{ test|show_query_headers }}</pre>
                          </div>
                          <div class="data row col-6">
                            <h6 class="col-3">Data<br>{{ test|show_query_datatype }}</h6>
                            <pre class="col-9">{{ test|show_query_data }}</pre>
                          </div>
                        </div>
                      {% elif test_type.value == 'readings' %}
                        <div class="row align-items-center">
                          <div class="col-1"></div>
                          <div class="col-3">
                            <div class="database">
                              <div>Base de datos {{test.database}}</div>
                              <div class="row">
                                <div class="col-6 text-right">Servicio:</div><div class="col-6 text-left">{{test.service}}</div>
                                <div class="col-6 text-right">Usuario:</div><div class="col-6 text-left">{{test.username}}</div>
                              </div>
                            </div>
                          </div>
                          <div class="col-1"></div>
                          <div class="sql col-6">
                            <h6>Consulta SQL</h6>
                            <pre>{{ test.sql|replace_env_vars:project.id }}</pre>
                          </div>
                        </div>
                        <div class="row mt-3">
                        </div>
                      {% endif %}
                    </div>
                  </div>
                  {% endif %}
                  {% if show_results %}
                  <div class="results">
                    <div class="card-body">
                      <h5 class="card-title">Resultados</h5>
                      {% if test_type.value == 'queries' %}
                        <div class="response row">
                          <h6 class="col-3">Respuesta {{ test|show_query_response_date }}</h6>
                          {% if test.response.responseType == 'json' %}
                          <pre class="col-9">{{test.response|json_response_formater}}</pre>
                          {% elif not test.response %}
                          <p class="col-9"> Esta prueba nunca se ha ejecutado </p>
                          {% else %}
                          <p class="col-9"> Respuesta de tipo HTML </p>
                          {% endif %}
                        </div>
                        <div class="expected-responses row">
                          <h6 class="col-3">Respuestas esperadas</h6>
                          <div class="col-9">
                            <div class="expected-data-header row">
                              <div class="variable col-3"><b>Variable</b></div>
                              <div class="comparison col-3"><b>Comparacion</b></div>
                              <div class="value col-3"><b>Valor esperado</b></div>
                              <div class="satisfied col-3"><b>Resultado</b></div>
                            </div>
                            {% for expected_data in test.query_expected_datas|to_list %}
                            <div class="expected-data row">
                              <div class="variable col-3">{{expected_data.variable|replace_env_vars:project.id}}</div>
                              <div class="comparison col-3">{{expected_data.comparison|comparison_string}}</div>
                              <div class="value col-3">{{expected_data.value|replace_env_vars:project.id}}</div>
                              <div class="satisfied col-3">{% if expected_data.satisfied %}{{expected_data.satisfied}}{% endif %}</div>
                            </div>
                            {% endfor %}
                          </div>
                        </div>
                      {% elif test_type.value == 'readings' %}
                        <div class="response row">
                          <h6 class="col-3">Variables asociadas</h6>
                          <div class="col-9">
                            {% for variables in test.reading_variables|to_list %}
                            {{variables.variables|show_variables|safe}}
                            {% endfor %}
                          </div>
                        </div>
                        <div class="validations row">
                          <h6 class="col-3">Validaciones</h6>
                          <div class="col-9">
                            {% for validation in test|show_reading_validations_comparisons %}
                            <div class="validation">
                              <!-- {{validation}} -->
                              <div class="row">
                                <div class="col-5 variable">
                                  <b>Variable Objetivo</b>
                                  <div>{{validation.variable}}</div>
                                </div>
                                <div class="col-7 description">
                                  <b>Descripcion</b>
                                  <div>{{validation.description}}</div>
                                </div>
                              </div>
                              <div class="code">
                                <b>Codigo de validacion</b>
                                <pre>{{validation.code}}</pre>
                              </div>
                            </div>
                            {% endfor %}
                            {% for validation in test|show_reading_validations_sequentials %}
                            <div class="validation">
                              <!-- {{validation}} -->
                              <div class="row">
                                <div class="col-5 variable">
                                  <b>Variable Objetivo</b>
                                  <div>{{validation.variable}}</div>
                                </div>
                                <div class="col-7 description">
                                  <b>Descripcion</b>
                                  <div>{{validation.description}}</div>
                                </div>
                              </div>
                              <div class="code">
                                <b>Codigo de validacion</b>
                                <pre>{{validation.code}}</pre>
                              </div>
                            </div>
                            {% endfor %}
                          </div>
                        </div>
                        <div class="file row">
                          <h6 class="col-3">Archivo resultante</h6>
                          <div class="col-9">
                            <a href="{{test.excel.url}}" class="excel">{{test.excel|filename}}</a>
                          </div>
                        </div>
                      {% endif %}
                    </div>
                  </div>
                  {% endif %}
                </div>
                {% endfor %}
              </div>
            </div>
            {% endfor %}
          </div>
        </div>
        {% endfor %}
      </div>
    </div>
    {% endfor %}
  </div>
</body>